diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/propagation/model/propagation-loss-model.cc ns-3.47/src/propagation/model/propagation-loss-model.cc
--- ns-3.46/src/propagation/model/propagation-loss-model.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/propagation/model/propagation-loss-model.cc	2026-02-16 16:08:49.812230800 -0800
@@ -209,20 +209,6 @@
 }
 
 double
-FriisPropagationLossModel::DbmToW(double dbm) const
-{
-    double mw = std::pow(10.0, dbm / 10.0);
-    return mw / 1000.0;
-}
-
-double
-FriisPropagationLossModel::DbmFromW(double w) const
-{
-    double dbm = std::log10(w * 1000.0) * 10.0;
-    return dbm;
-}
-
-double
 FriisPropagationLossModel::DoCalcRxPower(double txPowerDbm,
                                          Ptr<MobilityModel> a,
                                          Ptr<MobilityModel> b) const
@@ -370,20 +356,6 @@
 }
 
 double
-TwoRayGroundPropagationLossModel::DbmToW(double dbm) const
-{
-    double mw = std::pow(10.0, dbm / 10.0);
-    return mw / 1000.0;
-}
-
-double
-TwoRayGroundPropagationLossModel::DbmFromW(double w) const
-{
-    double dbm = std::log10(w * 1000.0) * 10.0;
-    return dbm;
-}
-
-double
 TwoRayGroundPropagationLossModel::DoCalcRxPower(double txPowerDbm,
                                                 Ptr<MobilityModel> a,
                                                 Ptr<MobilityModel> b) const
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/propagation/model/propagation-loss-model.h ns-3.47/src/propagation/model/propagation-loss-model.h
--- ns-3.46/src/propagation/model/propagation-loss-model.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/propagation/model/propagation-loss-model.h	2026-02-16 16:08:49.812230800 -0800
@@ -296,20 +296,6 @@
                          Ptr<MobilityModel> b) const override;
     int64_t DoAssignStreams(int64_t stream) override;
 
-    /**
-     * Transforms a Dbm value to Watt
-     * @param dbm the Dbm value
-     * @return the Watts
-     */
-    double DbmToW(double dbm) const;
-
-    /**
-     * Transforms a Watt value to Dbm
-     * @param w the Watt value
-     * @return the Dbm
-     */
-    double DbmFromW(double w) const;
-
     double m_lambda;     //!< the carrier wavelength
     double m_frequency;  //!< the carrier frequency
     double m_systemLoss; //!< the system loss (linear factor)
@@ -408,20 +394,6 @@
                          Ptr<MobilityModel> b) const override;
     int64_t DoAssignStreams(int64_t stream) override;
 
-    /**
-     * Transforms a Dbm value to Watt
-     * @param dbm the Dbm value
-     * @return the Watts
-     */
-    double DbmToW(double dbm) const;
-
-    /**
-     * Transforms a Watt value to Dbm
-     * @param w the Watt value
-     * @return the Dbm
-     */
-    double DbmFromW(double w) const;
-
     double m_lambda;       //!< the carrier wavelength
     double m_frequency;    //!< the carrier frequency
     double m_systemLoss;   //!< the system loss (linear factor)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/propagation/model/three-gpp-propagation-loss-model.cc ns-3.47/src/propagation/model/three-gpp-propagation-loss-model.cc
--- ns-3.46/src/propagation/model/three-gpp-propagation-loss-model.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/propagation/model/three-gpp-propagation-loss-model.cc	2026-02-16 16:08:49.812230800 -0800
@@ -298,7 +298,13 @@
                 "Enable/disable Building Penetration Losses.",
                 BooleanValue(true),
                 MakeBooleanAccessor(&ThreeGppPropagationLossModel::m_buildingPenLossesEnabled),
-                MakeBooleanChecker());
+                MakeBooleanChecker())
+            .AddAttribute("MeanVehicularLoss",
+                          "9dB for standard cars, 20dB for cars with "
+                          "metal coated glass panels.",
+                          DoubleValue(9),
+                          MakeDoubleAccessor(&ThreeGppPropagationLossModel::m_meanVehicleO2iLoss),
+                          MakeDoubleChecker<double>());
     return tid;
 }
 
@@ -317,11 +323,15 @@
 
     m_normalO2iLowLossVar = CreateObject<NormalRandomVariable>();
     m_normalO2iLowLossVar->SetAttribute("Mean", DoubleValue(0));
-    m_normalO2iLowLossVar->SetAttribute("Variance", DoubleValue(4.4));
+    m_normalO2iLowLossVar->SetStdDev(4.4);
 
     m_normalO2iHighLossVar = CreateObject<NormalRandomVariable>();
     m_normalO2iHighLossVar->SetAttribute("Mean", DoubleValue(0));
-    m_normalO2iHighLossVar->SetAttribute("Variance", DoubleValue(6.5));
+    m_normalO2iHighLossVar->SetStdDev(6.5);
+
+    m_normalO2iVehicularLossVar = CreateObject<NormalRandomVariable>();
+    // mean is set via an attribute, so must be set in NotifyConstructionCompleted
+    m_normalO2iVehicularLossVar->SetStdDev(5);
 }
 
 ThreeGppPropagationLossModel::~ThreeGppPropagationLossModel()
@@ -338,6 +348,12 @@
 }
 
 void
+ThreeGppPropagationLossModel::NotifyConstructionCompleted()
+{
+    m_normalO2iVehicularLossVar->SetAttribute("Mean", DoubleValue(m_meanVehicleO2iLoss));
+}
+
+void
 ThreeGppPropagationLossModel::SetChannelConditionModel(Ptr<ChannelConditionModel> model)
 {
     NS_LOG_FUNCTION(this);
@@ -401,16 +417,26 @@
          (cond->GetO2iCondition() == ChannelCondition::O2iConditionValue::I2I &&
           cond->GetLosCondition() == ChannelCondition::LosConditionValue::NLOS)))
     {
-        if (IsO2iLowPenetrationLoss(cond))
+        if (m_frequency < 6e9)
         {
-            rxPow -= GetO2iLowPenetrationLoss(a, b, cond->GetLosCondition());
+            // TR 38.901 has a backward compatibility O2I penetration loss for sub 6GHz channels
+            rxPow -= GetO2iSub6GhzPenetrationLoss(a, b, cond->GetLosCondition());
         }
         else
         {
-            rxPow -= GetO2iHighPenetrationLoss(a, b, cond->GetLosCondition());
+            if (IsO2iLowPenetrationLoss(cond))
+            {
+                rxPow -= GetO2iLowPenetrationLoss(a, b, cond->GetLosCondition());
+            }
+            else
+            {
+                rxPow -= GetO2iHighPenetrationLoss(a, b, cond->GetLosCondition());
+            }
         }
     }
 
+    rxPow -= GetO2iVehicularLoss(a, b, cond->GetO2iCondition());
+
     return rxPow;
 }
 
@@ -441,6 +467,69 @@
 }
 
 double
+ThreeGppPropagationLossModel::GetO2iSub6GhzPenetrationLoss(
+    Ptr<MobilityModel> a,
+    Ptr<MobilityModel> b,
+    ChannelCondition::LosConditionValue cond) const
+{
+    NS_LOG_FUNCTION(this);
+
+    double o2iLossValue = 0;
+    double lossTw = 0;
+    double lossIn = 0;
+    double lossNormalVariate = 0;
+
+    // compute the channel key
+    uint32_t key = GetKey(a, b);
+
+    bool notFound = false;     // indicates if the o2iLoss value has not been computed yet
+    bool newCondition = false; // indicates if the channel condition has changed
+
+    auto it = m_o2iLossMap.end(); // the o2iLoss map iterator
+    if (m_o2iLossMap.find(key) != m_o2iLossMap.end())
+    {
+        // found the o2iLoss value in the map
+        it = m_o2iLossMap.find(key);
+        newCondition = (it->second.m_condition != cond); // true if the condition changed
+    }
+    else
+    {
+        notFound = true;
+        // add a new entry in the map and update the iterator
+        O2iLossMapItem newItem;
+        it = m_o2iLossMap.insert(it, std::make_pair(key, newItem));
+    }
+
+    if (notFound || newCondition)
+    {
+        // distance2dIn is a single, link-specific, uniformly distributed variable
+        // between 0 and 25 m for UMa and UMi-Street Canyon.
+        double distance2dIn = GetO2iDistance2dInSub6Ghz();
+
+        // calculate penetration losses, see TR 38.901 Table 7.4.3-3
+        lossTw = 20;
+
+        // calculate indoor loss
+        lossIn = 0.5 * distance2dIn;
+
+        // calculate low loss standard deviation
+        lossNormalVariate = 0;
+
+        o2iLossValue = lossTw + lossIn + lossNormalVariate;
+
+        // update the entry in the map
+        it->second.m_o2iLoss = o2iLossValue;
+        it->second.m_condition = cond;
+    }
+    else
+    {
+        o2iLossValue = it->second.m_o2iLoss;
+    }
+
+    return o2iLossValue;
+}
+
+double
 ThreeGppPropagationLossModel::GetO2iLowPenetrationLoss(
     Ptr<MobilityModel> a,
     Ptr<MobilityModel> b,
@@ -497,16 +586,16 @@
         lowlossNormalVariate = m_normalO2iLowLossVar->GetValue();
 
         o2iLossValue = lowLossTw + lossIn + lowlossNormalVariate;
+
+        // update the entry in the map
+        it->second.m_o2iLoss = o2iLossValue;
+        it->second.m_condition = cond;
     }
     else
     {
         o2iLossValue = it->second.m_o2iLoss;
     }
 
-    // update the entry in the map
-    it->second.m_o2iLoss = o2iLossValue;
-    it->second.m_condition = cond;
-
     return o2iLossValue;
 }
 
@@ -569,16 +658,16 @@
         highlossNormalVariate = m_normalO2iHighLossVar->GetValue();
 
         o2iLossValue = highLossTw + lossIn + highlossNormalVariate;
+
+        // update the entry in the map
+        it->second.m_o2iLoss = o2iLossValue;
+        it->second.m_condition = cond;
     }
     else
     {
         o2iLossValue = it->second.m_o2iLoss;
     }
 
-    // update the entry in the map
-    it->second.m_o2iLoss = o2iLossValue;
-    it->second.m_condition = cond;
-
     return o2iLossValue;
 }
 
@@ -674,8 +763,8 @@
     m_randomO2iVar2->SetStream(stream + 2);
     m_normalO2iLowLossVar->SetStream(stream + 3);
     m_normalO2iHighLossVar->SetStream(stream + 4);
-
-    return 5;
+    m_normalO2iVehicularLossVar->SetStream(stream + 5);
+    return 6;
 }
 
 double
@@ -718,6 +807,67 @@
     }
 }
 
+double
+ThreeGppPropagationLossModel::GetO2iDistance2dInSub6Ghz() const
+{
+    return 0;
+}
+
+void
+ThreeGppPropagationLossModel::ClearO2iLossCacheMap()
+{
+    NS_LOG_FUNCTION(this);
+    m_o2iLossMap.clear();
+    m_o2iVehicularUtLossMap.clear();
+}
+
+double
+ThreeGppPropagationLossModel::GetO2iVehicularLoss(Ptr<MobilityModel> a,
+                                                  Ptr<MobilityModel> b,
+                                                  ChannelCondition::O2iConditionValue cond) const
+{
+    NS_LOG_FUNCTION(this);
+    double o2iVehicularLoss = 0.0;
+
+    // O2I penetration loss for vehicles only applies between 600 MHz and 60 GHz.
+    if (m_frequency >= 0.6e9 && m_frequency < 60e9)
+    {
+        for (const auto& mob : {a, b})
+        {
+            auto velocityKmH = mob->GetVelocity().GetLength() * 3.6;
+            auto idNode = mob->GetObject<Node>()->GetId();
+            // Slow nodes are considered as pedestrians (no loss)
+            if (velocityKmH < 30)
+            {
+                m_o2iVehicularUtLossMap[idNode] = 0.0;
+            }
+            // Fast nodes are considered vehicles.
+            // Create one loss per terminal, and reuse throughout simulation.
+            else if (velocityKmH >= 30 && velocityKmH <= 120)
+            {
+                if (m_o2iVehicularUtLossMap.find(idNode) == m_o2iVehicularUtLossMap.end())
+                {
+                    m_o2iVehicularUtLossMap[idNode] = m_normalO2iVehicularLossVar->GetValue();
+                }
+            }
+            // Very fast nodes are not modeled
+            else
+            {
+                m_o2iVehicularUtLossMap[idNode] = 0.0;
+                NS_LOG_WARN(
+                    "O2I loss for high-speed (>120 km/h) transit and satellites not implemented");
+            }
+
+            // Sum vehicle individual losses
+            if (cond == ChannelCondition::O2iConditionValue::O2O)
+            {
+                o2iVehicularLoss += m_o2iVehicularUtLossMap.at(idNode);
+            }
+        }
+    }
+    return o2iVehicularLoss;
+}
+
 // ------------------------------------------------------------------------- //
 
 NS_OBJECT_ENSURE_REGISTERED(ThreeGppRmaPropagationLossModel);
@@ -1099,6 +1249,13 @@
 }
 
 double
+ThreeGppUmaPropagationLossModel::GetO2iDistance2dInSub6Ghz() const
+{
+    // distance2dIn is a single, link-specific, uniformly distributed variable between 0 and 25 m.
+    return m_randomO2iVar1->GetValue(0, 25);
+}
+
+double
 ThreeGppUmaPropagationLossModel::GetLossNlos(Ptr<MobilityModel> a, Ptr<MobilityModel> b) const
 {
     NS_LOG_FUNCTION(this);
@@ -1150,20 +1307,25 @@
 {
     NS_LOG_FUNCTION(this);
     double shadowingStd;
-
-    if (cond == ChannelCondition::LosConditionValue::LOS)
-    {
-        shadowingStd = 4.0;
-    }
-    else if (cond == ChannelCondition::LosConditionValue::NLOS)
+    if (m_frequency < 6e9)
     {
-        shadowingStd = 6.0;
+        shadowingStd = 7.0;
     }
     else
     {
-        NS_FATAL_ERROR("Unknown channel condition");
+        if (cond == ChannelCondition::LosConditionValue::LOS)
+        {
+            shadowingStd = 4.0;
+        }
+        else if (cond == ChannelCondition::LosConditionValue::NLOS)
+        {
+            shadowingStd = 6.0;
+        }
+        else
+        {
+            NS_FATAL_ERROR("Unknown channel condition");
+        }
     }
-
     return shadowingStd;
 }
 
@@ -1196,9 +1358,9 @@
 {
     NS_LOG_FUNCTION(this);
 
-    m_normRandomVariable->SetStream(stream);
-    m_uniformVar->SetStream(stream + 1);
-    return 2;
+    int64_t streams = ThreeGppPropagationLossModel::DoAssignStreams(stream);
+    m_uniformVar->SetStream(stream + streams);
+    return streams + 1;
 }
 
 // ------------------------------------------------------------------------- //
@@ -1254,6 +1416,13 @@
 }
 
 double
+ThreeGppUmiStreetCanyonPropagationLossModel::GetO2iDistance2dInSub6Ghz() const
+{
+    // distance2dIn is a single, link-specific, uniformly distributed variable between 0 and 25 m.
+    return m_randomO2iVar1->GetValue(0, 25);
+}
+
+double
 ThreeGppUmiStreetCanyonPropagationLossModel::GetLossLos(Ptr<MobilityModel> a,
                                                         Ptr<MobilityModel> b) const
 {
@@ -1374,19 +1543,25 @@
     NS_LOG_FUNCTION(this);
     double shadowingStd;
 
-    if (cond == ChannelCondition::LosConditionValue::LOS)
-    {
-        shadowingStd = 4.0;
-    }
-    else if (cond == ChannelCondition::LosConditionValue::NLOS)
+    if (m_frequency < 6e9)
     {
-        shadowingStd = 7.82;
+        shadowingStd = 7.0;
     }
     else
     {
-        NS_FATAL_ERROR("Unknown channel condition");
+        if (cond == ChannelCondition::LosConditionValue::LOS)
+        {
+            shadowingStd = 4.0;
+        }
+        else if (cond == ChannelCondition::LosConditionValue::NLOS)
+        {
+            shadowingStd = 7.82;
+        }
+        else
+        {
+            NS_FATAL_ERROR("Unknown channel condition");
+        }
     }
-
     return shadowingStd;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/propagation/model/three-gpp-propagation-loss-model.h ns-3.47/src/propagation/model/three-gpp-propagation-loss-model.h
--- ns-3.46/src/propagation/model/three-gpp-propagation-loss-model.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/propagation/model/three-gpp-propagation-loss-model.h	2026-02-16 16:08:49.812230800 -0800
@@ -75,6 +75,13 @@
      */
     bool IsO2iLowPenetrationLoss(Ptr<const ChannelCondition> cond) const;
 
+    /**
+     * @brief Clear cached O2I Building Penetration loss.
+     *        Triggers a recomputation of losses.
+     *        Used for testing.
+     */
+    void ClearO2iLossCacheMap();
+
   private:
     /**
      * Computes the received power by applying the pathloss model described in
@@ -89,8 +96,6 @@
                          Ptr<MobilityModel> a,
                          Ptr<MobilityModel> b) const override;
 
-    int64_t DoAssignStreams(int64_t stream) override;
-
     /**
      * @brief Computes the pathloss between a and b
      * @param cond the channel condition
@@ -138,6 +143,22 @@
      *        independent realization and stores it in the map, otherwise it calculates
      *        a new value as defined in 3GPP TR 38.901 7.4.3.1.
      *
+     *
+     * @param a tx mobility model (used for the key calculation)
+     * @param b rx mobility model (used for the key calculation)
+     * @param cond the LOS/NLOS channel condition
+     * @return o2iLoss
+     */
+    double GetO2iSub6GhzPenetrationLoss(Ptr<MobilityModel> a,
+                                        Ptr<MobilityModel> b,
+                                        ChannelCondition::LosConditionValue cond) const;
+
+    /**
+     * @brief Retrieves the o2i building penetration loss value by looking at m_o2iLossMap.
+     *        If not found or if the channel condition changed it generates a new
+     *        independent realization and stores it in the map, otherwise it calculates
+     *        a new value as defined in 3GPP TR 38.901 7.4.3.1.
+     *
      *        Note that all child classes should implement this function to support
      *        low losses calculation. As such, this function should be purely virtual.
      *
@@ -169,6 +190,20 @@
                                              ChannelCondition::LosConditionValue cond) const;
 
     /**
+     * @brief Computes the o2i vehicular penetration loss by looking at m_o2iVehicularUtLossMap.
+     *        The loss is composed by the sum of losses for each UT, if vehicles,
+     *        as implied by their speed (30-120 km/h).
+     *        The loss for each UT is defined in 3GPP TR 38.901 7.4.3.2.
+     *
+     * @param a tx mobility model (used for the key calculation)
+     * @param b rx mobility model (used for the key calculation)
+     * @param cond the O2I channel condition (O2I, O2O)
+     * @return vehicular o2iLoss
+     */
+    double GetO2iVehicularLoss(Ptr<MobilityModel> a,
+                               Ptr<MobilityModel> b,
+                               ChannelCondition::O2iConditionValue cond) const;
+    /**
      * @brief Indicates the condition of the o2i building penetration loss
      *        (defined in 3GPP TR 38.901 7.4.3.1).
      *        The default implementation returns the condition as set
@@ -253,6 +288,18 @@
 
   protected:
     void DoDispose() override;
+    void NotifyConstructionCompleted() override;
+    /**
+     * @brief Returns a a single, link-specific, uniformly distributed variable
+     *        value depending on the specific 3GPP scenario (UMa, UMi-Street Canyon, RMa),
+     *        i.e., between 0 and 25 m for UMa and UMi-Street Canyon.
+     *        According to 3GPP TR 38.901 this 2D−in distance shall be UT-specifically
+     *        generated. 2D−in distance is used for the O2I penetration losses
+     *        calculation according to 3GPP TR 38.901 7.4.3.
+     *        See GetO2iLowPenetrationLoss/GetO2iHighPenetrationLoss functions.
+     * @return Returns 02i 2D distance (in meters) used to calculate low/high losses.
+     */
+    virtual double GetO2iDistance2dInSub6Ghz() const;
 
     /**
      * @brief Computes the 2D distance between two 3D vectors
@@ -265,8 +312,9 @@
     Ptr<ChannelConditionModel> m_channelConditionModel; //!< pointer to the channel condition model
     double m_frequency;                                 //!< operating frequency in Hz
     bool m_shadowingEnabled;                            //!< enable/disable shadowing
-    bool m_enforceRanges;                           //!< strictly enforce TR 38.901 parameter ranges
-    bool m_buildingPenLossesEnabled;                //!< enable/disable building penetration losses
+    bool m_enforceRanges;            //!< strictly enforce TR 38.901 parameter ranges
+    bool m_buildingPenLossesEnabled; //!< enable/disable building penetration losses
+    double m_meanVehicleO2iLoss; //!< normal cars (9dB), cars with metal coated glass panels (20dB)
     Ptr<NormalRandomVariable> m_normRandomVariable; //!< normal random variable
 
     /** Define a struct for the m_shadowingMap entries */
@@ -290,6 +338,11 @@
     mutable std::unordered_map<uint32_t, O2iLossMapItem>
         m_o2iLossMap; //!< map to store the o2i Loss values
 
+    mutable std::unordered_map<uint32_t, double>
+        m_o2iVehicularUtLossMap; //!< vehicular O2I loss for each individual UT with speed x, such
+                                 //!< that 30 < x <= 120 km/h.
+                                 //!< UT is addressed by NodeId
+
     Ptr<UniformRandomVariable> m_randomO2iVar1; //!< a uniform random variable for the calculation
                                                 //!< of the indoor loss, see TR38.901 Table 7.4.3-2
     Ptr<UniformRandomVariable> m_randomO2iVar2; //!< a uniform random variable for the calculation
@@ -300,6 +353,11 @@
     Ptr<NormalRandomVariable>
         m_normalO2iHighLossVar; //!< a normal random variable for the calculation of 02i high loss,
                                 //!< see TR38.901 Table 7.4.3-2
+
+    Ptr<NormalRandomVariable>
+        m_normalO2iVehicularLossVar; //!< a normal random variable for the calculation of
+                                     //!< penetration loss for vehicles see TR38.901 section 7.4.3.2
+    int64_t DoAssignStreams(int64_t stream) override;
 };
 
 /**
@@ -469,6 +527,18 @@
     double GetO2iDistance2dIn() const override;
 
     /**
+     * @brief Returns a a single, link-specific, uniformly distributed variable
+     *        value depending on the specific 3GPP scenario (UMa, UMi-Street Canyon, RMa),
+     *        i.e., between 0 and 25 m for UMa and UMi-Street Canyon.
+     *        According to 3GPP TR 38.901 this 2D−in distance shall be UT-specifically
+     *        generated. 2D−in distance is used for the O2I penetration losses
+     *        calculation according to 3GPP TR 38.901 7.4.3.
+     *        See GetO2iLowPenetrationLoss/GetO2iHighPenetrationLoss functions.
+     * @return Returns 02i 2D distance (in meters) used to calculate low/high losses.
+     */
+    double GetO2iDistance2dInSub6Ghz() const override;
+
+    /**
      * @brief Computes the pathloss between a and b considering that the line of
      *        sight is obstructed.
      * @param a tx mobility model
@@ -564,6 +634,18 @@
     double GetO2iDistance2dIn() const override;
 
     /**
+     * @brief Returns a a single, link-specific, uniformly distributed variable
+     *        value depending on the specific 3GPP scenario (UMa, UMi-Street Canyon, RMa),
+     *        i.e., between 0 and 25 m for UMa and UMi-Street Canyon.
+     *        According to 3GPP TR 38.901 this 2D−in distance shall be UT-specifically
+     *        generated. 2D−in distance is used for the O2I penetration losses
+     *        calculation according to 3GPP TR 38.901 7.4.3.
+     *        See GetO2iLowPenetrationLoss/GetO2iHighPenetrationLoss functions.
+     * @return Returns 02i 2D distance (in meters) used to calculate low/high losses.
+     */
+    double GetO2iDistance2dInSub6Ghz() const override;
+
+    /**
      * @brief Computes the pathloss between a and b considering that the line of
      *        sight is obstructed.
      * @param a tx mobility model
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/propagation/test/three-gpp-propagation-loss-model-test-suite.cc ns-3.47/src/propagation/test/three-gpp-propagation-loss-model-test-suite.cc
--- ns-3.46/src/propagation/test/three-gpp-propagation-loss-model-test-suite.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/propagation/test/three-gpp-propagation-loss-model-test-suite.cc	2026-02-16 16:08:49.813230800 -0800
@@ -1008,14 +1008,16 @@
      * @param hBs the BS height in meters
      * @param hUt the UT height in meters
      * @param distance the initial distance between the BS and the UT
-     * @param shadowingEnabled true if shadowging must be enabled
+     * @param shadowingEnabled true if shadowing must be enabled
+     * @param frequency channel frequency
      */
     void RunTest(uint16_t testNum,
                  std::string propagationLossModelType,
                  double hBs,
                  double hUt,
                  double distance,
-                 bool shadowingEnabled);
+                 bool shadowingEnabled,
+                 double frequency);
 
     /**
      * Compute the propagation loss
@@ -1023,7 +1025,7 @@
      * @param b the second mobility model
      * @param testNum the index of the experiment
      */
-    void EvaluateLoss(Ptr<MobilityModel> a, Ptr<MobilityModel> b, uint8_t testNum);
+    void EvaluateLoss(Ptr<MobilityModel> a, Ptr<MobilityModel> b, uint16_t testNum);
 
     /**
      * Change the channel condition model
@@ -1044,6 +1046,7 @@
                                   //!< case in dB
         double m_shadowingStdNlos; //!< the standard deviation of the shadowing component in the
                                    //!< NLOS case in dB
+        double m_frequency;        //!< channel frequency
     };
 
     TestVectors<TestVector> m_testVectors;         //!< array containing all the test vectors
@@ -1062,7 +1065,9 @@
 }
 
 void
-ThreeGppShadowingTestCase::EvaluateLoss(Ptr<MobilityModel> a, Ptr<MobilityModel> b, uint8_t testNum)
+ThreeGppShadowingTestCase::EvaluateLoss(Ptr<MobilityModel> a,
+                                        Ptr<MobilityModel> b,
+                                        uint16_t testNum)
 {
     double loss = m_lossModel->CalcRxPower(0, a, b);
     m_results.at(testNum).push_back(loss);
@@ -1080,7 +1085,8 @@
                                    double hBs,
                                    double hUt,
                                    double distance,
-                                   bool shadowingEnabled)
+                                   bool shadowingEnabled,
+                                   double frequency)
 {
     // Add a new entry for this test in the results map
     m_results[testNum] = std::vector<double>();
@@ -1102,9 +1108,10 @@
     // Create the propagation loss model
     ObjectFactory propagationLossModelFactory = ObjectFactory(propagationLossModelType);
     m_lossModel = propagationLossModelFactory.Create<ThreeGppPropagationLossModel>();
-    m_lossModel->SetAttribute("Frequency", DoubleValue(3.5e9));
+    m_lossModel->SetAttribute("Frequency", DoubleValue(frequency));
     m_lossModel->SetAttribute("ShadowingEnabled",
                               BooleanValue(shadowingEnabled)); // enable the shadow fading
+    m_lossModel->AssignStreams(testNum);
 
     // Set the channel condition to LOS
     Ptr<ChannelConditionModel> losCondModel = CreateObject<AlwaysLosChannelConditionModel>();
@@ -1163,6 +1170,9 @@
     // RMa, UMa, UMi and Indoor-Office.
 
     TestVector testVector;
+
+    // Above 6GHz
+    testVector.m_frequency = 6e9;
     testVector.m_propagationLossModelType = "ns3::ThreeGppRmaPropagationLossModel";
     testVector.m_hBs = 25;
     testVector.m_hUt = 1.6;
@@ -1171,6 +1181,7 @@
     testVector.m_shadowingStdNlos = 8;
     m_testVectors.Add(testVector);
 
+    testVector.m_frequency = 6e9;
     testVector.m_propagationLossModelType = "ns3::ThreeGppRmaPropagationLossModel";
     testVector.m_hBs = 25;
     testVector.m_hUt = 1.6;
@@ -1179,6 +1190,7 @@
     testVector.m_shadowingStdNlos = 8;
     m_testVectors.Add(testVector);
 
+    testVector.m_frequency = 6e9;
     testVector.m_propagationLossModelType = "ns3::ThreeGppUmaPropagationLossModel";
     testVector.m_hBs = 25;
     testVector.m_hUt = 1.6;
@@ -1187,6 +1199,7 @@
     testVector.m_shadowingStdNlos = 6;
     m_testVectors.Add(testVector);
 
+    testVector.m_frequency = 6e9;
     testVector.m_propagationLossModelType = "ns3::ThreeGppUmiStreetCanyonPropagationLossModel";
     testVector.m_hBs = 10;
     testVector.m_hUt = 1.6;
@@ -1195,6 +1208,7 @@
     testVector.m_shadowingStdNlos = 7.82;
     m_testVectors.Add(testVector);
 
+    testVector.m_frequency = 6e9;
     testVector.m_propagationLossModelType = "ns3::ThreeGppIndoorOfficePropagationLossModel";
     testVector.m_hBs = 3;
     testVector.m_hUt = 1;
@@ -1203,6 +1217,7 @@
     testVector.m_shadowingStdNlos = 8.03;
     m_testVectors.Add(testVector);
 
+    testVector.m_frequency = 6e9;
     testVector.m_propagationLossModelType = "ns3::ThreeGppV2vUrbanPropagationLossModel";
     testVector.m_hBs = 1.6;
     testVector.m_hUt = 1.6;
@@ -1211,6 +1226,7 @@
     testVector.m_shadowingStdNlos = 4;
     m_testVectors.Add(testVector);
 
+    testVector.m_frequency = 6e9;
     testVector.m_propagationLossModelType = "ns3::ThreeGppV2vHighwayPropagationLossModel";
     testVector.m_hBs = 1.6;
     testVector.m_hUt = 1.6;
@@ -1219,7 +1235,26 @@
     testVector.m_shadowingStdNlos = 4;
     m_testVectors.Add(testVector);
 
-    uint16_t numSamples = 250;
+    // Sub 6GHz
+    testVector.m_frequency = 3.5e9;
+    testVector.m_propagationLossModelType = "ns3::ThreeGppUmaPropagationLossModel";
+    testVector.m_hBs = 25;
+    testVector.m_hUt = 1.6;
+    testVector.m_distance = 100;
+    testVector.m_shadowingStdLos = 7;
+    testVector.m_shadowingStdNlos = 7;
+    m_testVectors.Add(testVector);
+
+    testVector.m_frequency = 3.5e9;
+    testVector.m_propagationLossModelType = "ns3::ThreeGppUmiStreetCanyonPropagationLossModel";
+    testVector.m_hBs = 10;
+    testVector.m_hUt = 1.6;
+    testVector.m_distance = 100;
+    testVector.m_shadowingStdLos = 7;
+    testVector.m_shadowingStdNlos = 7;
+    m_testVectors.Add(testVector);
+
+    uint16_t numSamples = 400;
 
     for (std::size_t tvIndex = 0; tvIndex < m_testVectors.GetN(); tvIndex++)
     {
@@ -1233,12 +1268,13 @@
                     tv.m_hBs,
                     tv.m_hUt,
                     tv.m_distance,
-                    true);
+                    true,
+                    tv.m_frequency);
         }
 
         // analyze the results
-        std::vector<double> mean_vector; // the vector containing the mean propagation loss for each
-                                         // position (sample mean)
+        std::vector<double> mean_vector; // the vector containing the mean propagation loss for
+                                         // each position (sample mean)
 
         uint16_t numPositions = m_results.at(0).size();
         for (uint16_t k = 0; k < numPositions; k++)
@@ -1259,7 +1295,8 @@
                 tv.m_hBs,
                 tv.m_hUt,
                 tv.m_distance,
-                false);
+                false,
+                tv.m_frequency);
         std::vector<double> true_mean =
             m_results.at(numSamples); // the result of the last test is the true mean
 
